import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import java.io.*;
import java.util.*;

public class JClientWindow extends JFrame implements TreeSelectionListener
{
	private JTitle	userTitle;
	private JTree	channelList;
	private JButton logout;
	private JButton	showMedia,closeMedia;
	private ObjectInputStream	inpStream = null;
//	private LogInPanel	loginPanel;
	private Client	client;
	//AVReceive3 player;
	private String	id;
	private String desc;
	private JLabel ldesc = new JLabel();
	boolean setUpCompleted  = false;
	StreamPlayer	player;
	
	JClientWindow(Client network)
	{
		super("BUET Video Network");
		
		client = network;
		
		userTitle = new JTitle(client.getUser());
		Font	font = new Font("Verdana",Font.BOLD,18);
		
		//JOptionPane.showConfirmDialog(null,"Channel View");
		
		Container c = getContentPane();
		
		c.setLayout(new BorderLayout(0,0));
		c.setBackground(Color.WHITE);
	
		c.add(userTitle,BorderLayout.NORTH);
		
		FillChannelList();
		setUpCompleted = true;
		//JScrollPane pane = new JScrollPane(channelList,ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
		//									ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		//JOptionPane.showMessageDialog(null,"adding");
		//c.add(pane,BorderLayout.CENTER);
		
		addWindowListener( new WindowAdapter()
				{
					public void windowClosing(WindowEvent event)
					{
						System.exit(0);
					}
				}
			);
		
		showMedia = new JButton("Show Media");
		closeMedia = new JButton("Close Media");
		logout = new JButton("Log Out");
		
		JPanel	buttonPanel = new JPanel();
		
		showMedia.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
							JClientWindow.this.startMedia();
					}
				}			
		);
		
		closeMedia.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				JClientWindow.this.closeMedia();
								
			}
		});
		buttonPanel.setLayout(new GridLayout(1,3));
		buttonPanel.add(showMedia);
		buttonPanel.add(closeMedia);
		buttonPanel.add(logout);
		
		logout.addActionListener(
		new ActionListener()
		{
			
			public void actionPerformed(ActionEvent arg0) {
				JClientWindow.this.doLogout();
				
			}
		}
		);
		
		c.add(buttonPanel,BorderLayout.SOUTH);
		
		setSize(300,600);
		Dimension d = this.getToolkit().getScreenSize();
		setLocation((int)(d.getWidth()-this.getWidth())/2,(int)(d.getHeight()-this.getHeight())/2);		
		
		
		setVisible(true);
	}
	private void doLogout()
	{
		client.sendData(new ChannelInfo("/logout",""));
		JOptionPane.showMessageDialog(this,client.getData());
		setVisible(false);
		VideoClient x = new VideoClient();
	}
	private void startMedia()
	{
		closeMedia();
		if(!id.equals("NONE"))
		{
			player = new StreamPlayer();
			client.sendData(new ChannelInfo("/media",id));
			
			String inp = client.getData();
			
			if(inp.charAt(0) != '+') return;
			
			StringTokenizer	tokenizer = new StringTokenizer(inp);
			
			System.out.println(inp);
			String[] rtpPort = new String[10];
			tokenizer.nextToken();
			int i =0;
			
			while(tokenizer.hasMoreTokens())
			{
				rtpPort[i++] = tokenizer.nextToken();
			}
			
			player.OpenRTP(client.getIP(),rtpPort,i);
		}
	}

	
	private void closeMedia()
	{
		if(player!=null)
		{
			client.sendData(new ChannelInfo("/stop",""));
			player.CloseRTP();
			client.getData();/* get the +stopped message */
			player = null;
		}
	}

	private void FillChannelList()
	{
		String	info,type = "";
		String	key,desc;
		//StringTokenizer
		
		DefaultMutableTreeNode	available = new DefaultMutableTreeNode("Shows");
		DefaultMutableTreeNode	subTree = null;
		
		//JOptionPane.showMessageDialog(null,"FillChannelList");
		client.sendData(new ChannelInfo("/list",""));
		
		while(true)
		{
			try
			{
				info = client.getData();
				
				//JOptionPane.showMessageDialog(null,info.channelName + ":" + info.identifier);
				
				if(info.equals("/###")) break;
				
				if(!info.equals(type))
				{
					subTree = new DefaultMutableTreeNode(info);
					available.add(subTree);
				}
				
				key = client.getData();
				desc = client.getData();			
				
				subTree.add(new DefaultMutableTreeNode(new ChannelInfo(desc,key)));
			}
			catch(Exception e)
			{
				break;
			}
		}
		
		channelList = new JTree(available);
		channelList.getSelectionModel().setSelectionMode
        (TreeSelectionModel.SINGLE_TREE_SELECTION);
		
		channelList.addTreeSelectionListener(this);
		
		JScrollPane	pane = new JScrollPane(channelList);
		getContentPane().add(pane,BorderLayout.CENTER);
		
		
	}
	
	public void valueChanged(TreeSelectionEvent e)
	{
        DefaultMutableTreeNode node = 
        	(DefaultMutableTreeNode)channelList.getLastSelectedPathComponent();

        if (node == null) return;
        
        Object nodeInfo = node.getUserObject();
		
		if (node.isLeaf())
		{
			ChannelInfo	info = (ChannelInfo)nodeInfo;
			
			//JOptionPane.showConfirmDialog(null,info.channelName + ": " + info.identifier);
			id = info.identifier;
		}
		else
			id = "NONE";
		
		ldesc.setText(id);
		
		
	}
	
}
